# Main install tasklist for Nexus and related products.

- name: Create Namespace
  include_role:
    name: common/namespace
    tasks_from: namespace.yml
  vars:
    namespace: "{{ config.nexus.namespace }}"

- name: Include k8s resource vars from "{{ config.nexus.k8_resources_file }}"
  include_vars:
    file: "{{ config.nexus.k8_resources_file }}"
    name: resources_config_defaults
  when: config.nexus.k8_resources_file is defined
  tags: always 

- name: merge config into resources_config - this allows overriding the default requests and limits
  set_fact: 
    resources_config: "{{ resources_config_defaults.config.nexus | default({}) | combine(config.nexus ,recursive=true) }}"
  tags: always 

- name: Set OpenShift security context constraints
  include: scc.yml
  when: (config.system.k8s_distribution is defined) and (config.system.k8s_distribution == 'openshift')

- name: Ensure temp directory exists
  file:
    path: "{{ install_dir }}/nexus"
    state: directory

- name: OIDC Client
  include_tasks: oidc/oidc.yml

- name: Deployment of Ingresses
  k8s:
    state: present
    definition: "{{ lookup('template', item) }}"
  loop:
    - "nexus_oauth_ingress.yml"
    - "nexus_provision_ingress.yml"
    - "nexus_basic_auth_ingress.yml"
    - "nexus_api_ingress.yml"

- name: Helm install Nexus
  include_tasks: install_nexus.yml

